#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Aug 20 11:30:26 2019

@author: minh
"""

def has_repeated_substr(s, length):
    '''
    Return a substring of the given length that 
    occurs at least twice in the string s
    '''
    start = 0
    # sliding window approach
    while start + length <= len(s):
        sub = s[start:(start+length)]
        # check if sub occurs later in s
        if s[(start+1):].find(sub) >= 0:
            return sub
        start += 1
    return None

def longest_repeated_substr(s):
    '''
    Return the longest repeated substring 
    of a given string s
    '''
    length = 1
    longest = ''
    # iterate over all length from 1 to len(s)-1
    while length < len(s):
        sub = has_repeated_substr(s, length)
        if sub is not None:
            longest = sub
        length += 1
    return longest


print(longest_repeated_substr('backpack'))
print(longest_repeated_substr('singing'))
print(longest_repeated_substr('philosophically'))
print(longest_repeated_substr('programming'))
print(longest_repeated_substr('problem'))
